package me.Demon.DemonShop;

import me.Demon.DemonPlugin.DemonAPI;
import me.Demon.DemonShop.gui.CreateGui;
import me.Demon.DemonShop.gui.ShopGui;
import org.bukkit.Bukkit;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.configuration.file.YamlConfiguration;
import org.bukkit.entity.Player;
import org.bukkit.event.Listener;
import org.bukkit.inventory.ItemStack;
import org.bukkit.plugin.java.JavaPlugin;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Objects;

public class Main extends JavaPlugin implements Listener {

    public static Main plugin;
    public static String prefix = "§7[§6商店§7] §f";
    public static List<String> file_Name = new ArrayList<>();
    public static HashMap<Player, ItemStack> hashItems = new HashMap<>();
    public static HashMap<Player, Integer> hashPrice = new HashMap<>();
    public static HashMap<Player, Integer> hashAmount = new HashMap<>();

    @Override
    public void onEnable() {
        plugin = this;
        saveDefaultConfig();
        Bukkit.getConsoleSender().sendMessage("§e[DemonShop] §r正在启动插件...");
        getServer().getPluginManager().registerEvents(this, this);
        Bukkit.getServer().getPluginManager().registerEvents(new CreateGui(), plugin);
        Bukkit.getServer().getPluginManager().registerEvents(new ShopGui(), plugin);
        loadFile_NameData();
    }

    public void loadFile_NameData() {
        File plans = new File("./plugins/DemonShop", "商店配置");
        File[] files = plans.listFiles();
        File[] arrayOfFile1;
        int j = (Objects.requireNonNull(arrayOfFile1 = files)).length;
        for (int i = 0; i < j; i++) {
            File s = arrayOfFile1[i];
            file_Name.add(s.getName().replace(".yml", ""));
        }
    }

    public void onDisable() {
        Bukkit.getConsoleSender().sendMessage("§e[DemonShop] §r正在关闭插件...");
    }


    public boolean onCommand(CommandSender sender, Command cmd, String Command, String[] args) {
        if (Command.equalsIgnoreCase("dshop")) {
            if (args.length == 3 && args[0].equalsIgnoreCase("open")) {
                String key = args[1];
                if (!file_Name.contains(key)) {
                    sender.sendMessage("该商店不存在,请联系[客服]进行修复.");
                    return true;
                }
                File file = new File("plugins/DemonShop/商店配置", key + ".yml");
                YamlConfiguration yml = YamlConfiguration.loadConfiguration(file);
                Player p = Bukkit.getPlayer(args[2]);
                if (p != null) {
                    ShopGui.OpenGui(p, key, yml);
                } else {
                    sender.sendMessage("目标玩家不在线.");
                }
            }
            if (args.length == 2 && args[0].equalsIgnoreCase("open")) {
                String key = args[1];
                if (!file_Name.contains(key)) {
                    sender.sendMessage("该商店不存在,请联系[客服]进行修复.");
                    return true;
                }
                File file = new File("plugins/DemonShop/商店配置", key + ".yml");
                YamlConfiguration yml = YamlConfiguration.loadConfiguration(file);
                ShopGui.OpenGui((Player) sender, key, yml);
            }
        }
        if (Command.equalsIgnoreCase("dshops") && sender.isOp()) {
            if (args.length == 0) {
                sender.sendMessage("/dshops [代号] [价格] [数量]");
            }
            if (args.length == 1 && args[0].equalsIgnoreCase("reload")) {
                file_Name.clear();
                loadFile_NameData();
                sender.sendMessage(prefix + "重载完成.");
            }
            if (args.length == 3) {
                Player p = (Player) sender;
                String key = args[0];
                File file = getFilePath(key);
                if (file == null) {
                    sender.sendMessage("请检查该文件配置是否存在.");
                    return true;
                }
                YamlConfiguration yml = YamlConfiguration.loadConfiguration(file);
                ItemStack item = p.getInventory().getItemInHand();
                if (!DemonAPI.itemIsNull(item) && !DemonAPI.itemIsLore(item)) {
                    int price = Integer.parseInt(args[1]);
                    int amount = Integer.parseInt(args[2]);
                    hashItems.put(p, item);
                    hashPrice.put(p, price);
                    hashAmount.put(p, amount);
                    CreateGui.OpenGui(p, key, yml);
                } else {
                    sender.sendMessage(prefix + "手持物品出现错误,请检查后再次使用.");
                }
            }
        }
        return false;
    }


    public static File getFilePath(String name) {
        File plans = new File("./plugins/DemonShop", "商店配置");
        File[] files = plans.listFiles();
        File[] arrayOfFile1;
        int j = (Objects.requireNonNull(arrayOfFile1 = files)).length;
        for (int i = 0; i < j; i++) {
            File s = arrayOfFile1[i];
            if (s.getName().equals(name + ".yml"))
                return s;
        }
        return null;
    }

    public static void saveFileConfig(YamlConfiguration yml, File file) {
        try {
            yml.save(file);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
